/* Specification:
Created/Revised by Barbara Williams on September 8, 2010
Ch. 12 Lab 2
This lab writes a program that contains a class that implements the days of
the week. The program is able to perform the following on an object of the 
class. Set the day, Print the day, Return the day, Return the next day,
Return the previous day, and Calculate and Return the day by adding a
certain amount of days to the current day.*/

/* DaysOfTheWeekImp.cpp, the implementation file - The user program that 
uses DaysOfTheWeek class. */

// Required by cout command
#include <iostream>

// Required by string data type
#include <string>

// Required by class
#include "The DaysOfTheWeek.h"

using namespace std;

// Definitions of the member functions of the class DaysOfTheWeek.
DaysOfTheWeek::DaysOfTheWeek()
{
	// sets the data member by default to the first day of the week.
	day = "Sunday";
	
}	// end default constructor

DaysOfTheWeek::~DaysOfTheWeek
{
	
} 	// end destructor

void DaysOfTheWeek::setDay(string wkDay)
{
	//sets the data member literally from what is passed as a parameter
	day = wkDay;
	
}	// end setDay mutator method

string DaysOfTheWeek::getDay()
{
	// returns the value stored in the data member
	return day;
	
}	// end getDay accessor method

void DaysOfTheWeek::printDay()
{
	cout << day
	
}	// end printDay method

string DaysOfTheWeek::plusOneDay()
{
	int num = 1;
	return addDays(num);
	
}	// end plusOneDay method

string DaysOfTheWeek::minusOneDay()
{
	int num = -1;
	return addDays(num);
	
}	// end minusOneDay method

string DaysOfTheWeek::addDays(int num)
{
	// an array of days of the week
	string dayNames[7] =
	{"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday",
	"Saturday"};
	
	num = num % 7;
	
	// for loop counter variable
	int i; 
	
	// used to determine what day it really is
	int theDayNumber;
	
	/* compare the data member (day) with the array of strings to find the
	index of the current day */
	for(i = 0; i < 7; i++)
	{
		if(dayNames[i] == day)
		{
			theDayNumber = i;
			
		}	// end if statement
	}	// end for statement
	
	// Add theDayNumber to input to figure out what day it should return.
	theDayNumber += num;
	
	/* If the day is less than Sunday, add 7 days to get it back in the
	week. */
	if(theDayNumber < 0)
	{
		theDayNumber += 7;
	}
	
	/* If the day is greater than Saturday, subtract 7 to get it back in
	the week. */
	if(theDayNumber > 6)
	{
		theDayNumber -= 7;
	}
	
	return dayNames[theDayNumber];
	
}	// end addDays method