/* Specification:
Created/Revised by Barbara Williams on September 8, 2010
Ch. 12 Lab 2
This lab writes a program that contains a class that implements the days of
the week. The program is able to perform the following on an object of the 
class. Set the day, Print the day, Return the day, Return the next day,
Return the previous day, and Calculate and Return the day by adding a
certain amount of days to the current day.*/

/* DaysOfTheWeek.h the specification file for the class DaysOfTheWeek
Class "DaysOfTheWeek" contains three public member functions and one
private data member variable.*/

// Required by cout command
#include <iostream>

// Required by string data type
#include <string>

// Default namespace defining library functions (e.g. cout, endl)
using namespace std;

class DaysOfTheWeek
{
	public:
		/* A mutator method called setDay that takes a string as a parameter and
		returns void. Function is to set the day. The day is set according to the
		parameter. Postconditions: day  wkDay
		The function checks whether the value of wkDay is valid. If value is 
		invalid the default value is assigned.*/
		void setDay(string wkDay);
		
		/* An accessor method called getDay which returns a string and takes no 
		parameters. Function is to return the day. Postconditions: day   wkDay  */
		string getDay();
		
		/* An accessor method called plusOneDay that returns a string and takes no
		parameters, calls addDays with 1 as a parameter, and increments day plus 
		one. Function is to add one day to the current day. Postconditions: day++; */
		string plusOneDay();
		
		/* An accessor method called minusOneDay returns a string and takes no 
		parameters, calls addDays with -1 as a parameter. Function is to subtract one
		day from the current day. Postconditions: day--; */
		string minusOneDay();
		
		/* A method called addDays returns a string and takes one integer parameter,
		adds a number of days (parameter) to the current day and returns the new day
		as a string - uses a local array of strings. Function is to add days to the
		curent day. Postconditions:    */
		string addDays(int);
		
		/* Default constructor - Function is to assign a string(a day of the week) to
		day. The day is set to "Sunday". Postconditions: day = "Sunday"   */
		DaysOfTheWeek();
		
		/* Destructor - Function is automatically called when an object is destroyed,
		either because its scope of existence has finished or because it is an object
		dynamically assigned and it is released using the operator delete. 
		Postconditions:   */
		~DaysOfTheWeek();
		
	private:
		// Data member (variable) to store the day.
		string day;
};